;	M4HOET2/ASM
; CONTAINS CODE FOR SET & SHOW
; EXTRACTED FROM M4MORE 01 APR 86 DAVORK
; THIS IS THE SET COMMAND.
SETCOM	LD	DE,SETTAB	; PARSE A KEYWORD FROM THE SET TABLE.
	LD	A,SHLEN/3	;CHANGE NUMBER OF ENTRIES BACK
	LD	(SETTAB),A	;DO IT
	LD	A,MXSLEN	; GET MAX LENGTH ENTRY FOR SET TABLE
	LD	(SETTAB+1),A
	LD	HL,SETHLP	; GET ADDRESS OF HELP (NOT USED IN COMND)
	LD	(HL),CR		;PATCH ANY CHANGES MADE BY SHOW
	LD	A,CMKEY
	CALL	COMND
	JP	KERMT2
	LD	HL,SETJTB	; GET THE ADDRESS OF THE JUMP TABLE.
	LD	C,A
	LD	B,0
	ADD	HL,BC
	JP	(HL)  
;	SET COMMAND JUMP TABLE
SETJTB	JP	ESCAPE		; SET ESC
	JP	LOCAL		; SET LOCAL
	JP	FILWAR		; SET WARNING
	JP	SETCPM		; SET FILE-MODE
	JP	BLKSET		; SET BLOCK-CHECK-TYPE
	JP	VT52EM		; SET VT52
	JP	PRINTR		; set printer
	JP	SETBUG		; SET DEBUG
	JP	SETDSK		; SET DEFAULT DISK
	JP	SETBEL		; SET BELL ON OR OFF
	JP	SETBAU		; SET BAUD RATE
	JP	IBMSET		; SET IBM MODE
	JP	SETPAR		; SET PARITY
	JP	SETSND		; SET SEND PARAMETERS
	JP	SETREC		; SET RECEIVE PARAMTERS
	JP	SETBCK
	JP	SETKEY		; SET A KEY FOR TRANSLATION
	JP	SETFLO		; SET FLOW CONTROL
	JP	SETINP		; SET INPUT PARAMETERS
	JP	SETOTP		; SET OUTPUT PARAMETERS
	JP	SETTAK
	JP	SETSTR		; SET STRIP-EIGHTH-BIT	31 MAR 86 DAVORK
	JP	SETWLN		; SET WORD LENGTH	13 APR 86 DAVORK
	JP	SETSTB		; SET STOP-BITS		13 APR 86 DAVORK
	JP	SETRTS		; SET RTS		13 APR 86 DAVORK
	JP	SETDTR		; SET DTR		13 APR 86 DAVORK
SHLEN	EQU	$-SETJTB	; OFFSET FOR SHOW ALL
SETSTR	CALL	ONOFF				; 31 MAR 86 DAVORK
	LD	(STRFLG),A			; 31 MAR 86 DAVORK
	JP KERMIT				; 31 MAR 86 DAVORK
SETRTS	CALL	ONOFF				; 13 APR 86 DAVORK
	OR	A				; AS IS CODE FOR SETDTR
	LD	A,(CLCOPY)	; GET COPY OF UART
	JR	Z,SETR10	; AND ALTER AS NECESSARY
	RES	0,A
	JR	SETR20
SETR10	SET	0,A
SETR20	LD	(CLCOPY),A	; SAVE COPY
	JP	KERMIT		; GO TO KERMIT
SETDTR	CALL	ONOFF		; DO SAME AS SETRTS, EXCEPT THIS TIME FOR DTR
	OR	A
	LD	A,(CLCOPY)
	JR	Z,SETD20
	RES	1,A
	JR	SETR20
SETD20	SET	1,A
	JR	SETR20
SETWLN	LD	DE,WLENTB
	LD	A,CMKEY
	CALL	COMND		; PARSE A KEYWORD
	JP	KERMT2		; SAY AMBIGOUS
	LD	(SETW10+1),A	; SAVE PARSED ITEM
	LD	A,CMCFM		; WANNA END COMMAND
	CALL	COMND
	JP	KERMT3
	LD	A,(CLCOPY)
	AND	10011111B	; MASK OUT OLD WORD LENGTH
SETW10	OR	0		; MASK IN NEW WORD LENGTH
	LD	(CLCOPY),A	; SAVE CONTROL IMAGE
	JP	KERMIT		; GO GET ANOTHER COMMAND
SETSTB	LD	DE,STOPTB	; STOP BITS TABLE
	LD	A,CMKEY		; PARSE A KEYWORD
	CALL	COMND
	JP	KERMT2		; SAY AMBIGOUS
	LD	(SETS10+1),A	; SAVE FOR LATER MASKING IN
	LD	A,CMCFM		; WANNA FINISH
	CALL	COMND
	JP	KERMT3		; NOT TONITE JOSEPHINE...
	LD	A,(CLCOPY)	; GET OLD CONTROL IMAGE
	AND	11101111B
SETS10	OR	0		; UPDATE IT
	LD	(CLCOPY),A	; SAVE NEW CONTROL IMAGE
	JP	KERMIT		; GO HOME TO Miss Piggy
SETTAK	CALL	ONOFF
	LD	(TAKLOG),A
	JP	KERMIT
SETBAU	LD	DE,SPDTB1
	LD	A,CMKEY
	CALL	COMND
	JP	KERMT2
	LD	(SETB10+1),A	; GOT TRANSMIT OR RECEIVE
	LD	DE,SPDTAB
	LD	A,CMKEY
	CALL	COMND
	JP	KERMT2
	LD	(SETB30+3),A
	LD	A,D
	LD	(SETB40-1),A
	LD	A,CMCFM
	CALL	COMND
	JP	KERMT3
SETB10	LD	A,0		; CHECK FOR TRANSMIT(0) OR RECEIVE (1)
	OR	A
	LD	A,(CLCOPY+1)
	JR	NZ,SETB30
	AND	00001111B
	OR	0
SETB40	LD	(CLCOPY+1),A
	JP	KERMIT
SETB30	AND	11110000B
	OR	0
	JR	SETB40
SETPAR	LD	DE,PARTAB
	LD	A,CMKEY
	CALL	COMND
	JP	KERMT2
	LD	(SETP10+1),A
	LD	A,CMCFM
	CALL	COMND
	JP	KERMT3
	LD	A,(CLCOPY)
	AND	01110111B
SETP10	OR	0
	LD	(CLCOPY),A
	JP	KERMIT
SETINP	LD	A,CMKEY		; GET A KEYWORD
	LD	DE,INPTAB	; WHERE ARE THE KEYWORDS AT?
	CALL	COMND
	JP	KERMT2		; QUIT ON AN ERROR
	CP	0		; CHECK FOR FIRST
	JR	NZ,STINP1
	CALL	ONOFF		; GET ON OR OFF
	LD	(CSEFLG),A	; GET CASE IGNORE
	JP	KERMIT
STINP1	CP	3
	JP	NZ,KERMT3
	CALL	ONOFF
	LD	(INDSP),A
	JP	KERMIT
SETOTP	LD	A,CMKEY
	LD	DE,OUTTAB
	CALL	COMND
	JP	KERMT2
	CP	0
	JR	NZ,STOTP1
	CALL	ONOFF
	LD	(ECHFLG),A
	JP	KERMIT
STOTP1	CP	3
	JP	NZ,KERMT3
	CALL	ONOFF
	LD	(OTDSP),A
	JP	KERMIT
SETFLO	LD	DE,FLOTAB
	LD	A,CMKEY
	CALL	COMND
	JP	KERMT2
	LD	(TEMP1),A
	LD	A,CMCFM
	CALL	COMND
	JP	KERMT3
	LD	A,(TEMP1)
	LD	(FLOFLG),A	;STORE THE NEW STATUS
	JP	KERMIT
SAVKY1	DW	0		; STORAGE FOR FROM KEY VALUE OFFSET
SAVKY2	DW	0		; STORAGE FOR TO VALUE
SETKEY	LD	A,CMNUM		; PARSE AN INPUT NUMBER
	CALL	COMND
	JP	KERMT2
	OR	A		; CHECK FOR NO NUMBER
	JP	Z,KERMT2	; SAY AMBIGOUS
	LD	(SAVKY1),DE	; SAVE THE FROM VALUE
	LD	A,D		; CHECK FOR OVERFLOW
	OR	A
	JR	NZ,SETK05	; GO IF THERE WAS
	LD	A,CMNUM		; GET THE TO VALUE
	CALL	COMND
	JP	KERMT3
	OR	A		; CHECK FOR NO NUMBER
	JP	Z,KERMT2	; SAY AMBIGUOUS
	LD	(SAVKY2),DE	; SAVE THE TO VALUE
	LD	A,D
	OR	A
	JR	NZ,SETK05
	LD	A,CMCFM		; GET A CONFIRM
	CALL	COMND
	JP	KERMT3		; SAY NOT-CONFIRMED
	LD	DE,(SAVKY2)
	JR	SETK10
SETK05	LD	DE,OUTRNG	; PRINT THE OUT OF RANGE MESSAGE
	CALL	PRTSTR
	JP	KERMIT
SETK10	LD	BC,(SAVKY1)	; GET THE FROM VALUE
	LD	HL,TRNCON	; GET THE START OF THE TABLE
	ADD	HL,BC		; POINT TO THE KEY
	LD	(HL),E		; SET THE NEW VALUE
	JP	KERMIT
KYSTAT	LD	A,CMNUM		; GET WHICH KEY
	CALL	COMND		; GET IT
	JP	KERMT3		; SAY NOT CONFIRMED
	OR	A		; CHECK FOR NO NUMBER
	JP	Z,KERMT2	; SAY AMBIGUOUS
	LD	A,D		; CHECK FOR OVERFLOW
	OR	A
	JP	NZ,SETK05
	LD	HL,TRNCON	; GET THE TABLE
	ADD	HL,DE		; CALCULATE THE ADDRESS
	LD	A,(HL)		; GET THE CHARACTER THERE
	PUSH	AF		; SAVE IT
	LD	DE,KEYST	; PRINT THE DESCRIPTION STRING
	CALL	PRTSTR
	POP	AF		; RESTORE THE VALUE
	CALL	ANOUT		; PRINT THE VALUE THERE
	RET			; RETURN 
SETBCK	LD	A,CMKEY		; GET A KEYWORD
	LD	DE,BCKTAB	; GET THE KEYWORDS
	CALL	COMND		; GET THE KEYWORD
	JP	KERMT2		; SAY AMBIGUOUS
	LD	(TEMP1),A	; SAVE THE BACKSPACE THAT WE GOT
	LD	A,CMCFM		; GET A CONFIRM
	CALL	COMND
	JP	KERMT3		; SAY NOT CONFIRMED
	LD	A,(TEMP1)	; GET THE VALUE FROM THE PARSE
	LD	(BCKCHR),A	; STORE THE NEW BACKSPACE CHARACTER
	JP	KERMIT		; GET A NEW COMND
SETBEL	CALL	ONOFF		; GET ON OR OFF
	LD	(BELFLG),A	; STORE THE FLAG VALUE
	JP	KERMIT		; GET A NEW COMMAND
BLKSET	LD	DE,BLKTAB	; GET THE ADDRESS OF THE BLOCK-CHECK TABLE
	LD	A,CMKEY		; PARSE A KEYWORD
	CALL	COMND		; GO GET IT
	JP	KERMT2		; COULDN'T, COMPLAIN
	LD	(TEMP1),A	; SAVE THE PARSED ITEM
	LD	A,CMCFM		; WANT TO END THE COMMAND
	CALL	COMND		; GO DO IT
	JP	KERMT3		; GIVE UP
	LD	A,(TEMP1)	; GET THE VALUE BACK
	LD	(CHKTYP),A	; SAVE DESIRED CHECKSUM TYPE
	JP	KERMIT		; GO GET ANOTHER COMMAND
;
;
SETSND	XOR	A		;SET SEND/RECEIVE TO SEND
	JR	SETSOR
;
;
SETREC	LD	A,1		;SET SEND/RECEIVE TO RECEIVE
SETSOR	LD	(SORFLG),A	; STORE THE FLAG
	LD	DE,STSNTB	; GET THE PARSE TABLE
	LD	A,CMKEY
	CALL	COMND		; PARSE SOMETHING
	JP	KERMT2		; ABORT
	LD	HL,STSJTB	; GET THE JUMP TABLE
	LD	C,A
	LD	B,0
	ADD	HL,BC
	JP	(HL)
STSJTB	JP	STPDCH		; SET PAD CHARACTER
	JP	STPAD		; SET PADDING ON/OFF
	JP	SSOFP		; SET START OF PACKET
	JP	STIMEO		; SET TIME OUT
	JP	SSEOL		; SET END OF LINE
	JP	SSQUOT		; SET QUOTE CHARACTER
STPAD	LD	A,CMNUM		;GET A LENGTH COUNT
	CALL	COMND		; PARSE A VALUE
	JP	KERMT3		; NOT CONFIRMED ON AN ERROR
	OR	A		; CHECK FOR NO NUMBER
	JP	Z,KERMT2	; SAY AMBIGUOUS
	LD	A,D		; CHECK FOR OVERFLOW
	OR	A		; SET THE FLAGS
	JR	Z,STPD10	; GOT IF NONE
	LD	DE,OUTRNG
	CALL	PRTSTR
	JP	KERMIT
STPD10	LD	A,E
	LD	(SPAD),A		; SET THE STATUS
	JP	KERMIT		; GET A NEW COMMAND
STPDCH	LD	HL,SPADCH	; GET THE ADDRESS TO STORE AT
SOR010	LD	(SORLOC),HL	; SAVE IT FOR LATER
	LD	A,CMNUM		;GET A DECIMAL NUMBER
	CALL	COMND
	JP	KERMT3
	OR	A		; CHECK FOR NO NUMBER
	JP	Z,KERMT2	; SAY AMBIGUOUS
	LD	A,D		;CHECK FOR TOO BIG
	OR	A		;SET THE FLAGS
	JR	Z,PDCH2		;GO IF OK
	LD	DE,OUTRNG	;VALUE OUT OF RANGE ERROR
	CALL	PRTSTR		;PRINT IT
	JP	KERMIT
PDCH2	LD	HL,(SORLOC)	;GET WHERE TO PUT IT
	LD	A,(SORFLG)	;GET THE MODE, SEND/RECEIVE
	OR	A		;CHECK FOR SET OR RESET FLAG
	CALL	Z,SSVAL		;IF ZERO THEN SET RECEIVE VALUE
	CALL	NZ,SRVAL		;ELSE SET THE SEND VALUE
	JP	KERMIT		;GET A NEW COMMAND
;	SET SEND/RECEIVE START-OF-PACKET character
SSOFP	LD	HL,SSOHCH
	JP	SOR010
;	Set SEND/RECEIVE	TIME-OUT value
STIMEO	LD	HL,STIME
	JP	SOR010
;	Set SEND/RECEIVE END-OF-LINE character
SSEOL	LD	HL,SEOL
	JP	SOR010
;	Set SEND/RECEIVE quoting character
SSQUOT	LD	HL,SQUOTE
	JP	SOR010
;	Convert ASCII Decimal string to binary in BC, HL is the source buffer
DECHEX	LD	A,96
	RST	28H
	RET
;	Store E at HL
SRVAL	LD	(HL),E
	RET
;	Store E at HL+1
SSVAL	INC	HL
	LD	(HL),E
	RET
;	PRINT OUT THE ACCUMLATOR IN ASCII ON THE SCREEN AT CURRENT POS
ANOUT	PUSH	HL
	LD	L,A
	LD	H,0
	CALL	NOUT
	POP	HL
	RET
ESCAPE	LD	A,CMCFM		; NOT (BRAIN OR OSBRN1 OR KPII)
				; ^ SILLY COMMENT FOR A TRS-80 Model IV !
	CALL	COMND		; GET A CONFIRM.
	JP	KERMT3		;  DIDN'T GET A CONFIRM.
	LD	DE,ESCMES	; GET THE ADDRESS OF THE ESCAPE MESSAGE.
	CALL	PRTSTR
	CALL	XKEY
	LD	(ESCCHR),A	; STORE THE NEW ESCAPE CHARACTER.
	CALL	ESCPR		; Print the Verbpse description of it
	JP	KERMIT
;	THIS IS THE LOCAL ECHO SET SUBCOMMAND.
LOCAL	CALL	ONOFF
	LD	(ECOFLG),A	; SET THE LOCAL ECHO FLAG.
	JP	KERMIT
;	THIS IS THE VT52 EMULATION SET SUBCOMMAND.
VT52EM	CALL	ONOFF
	LD	(VTFLG),A	; SET THE VT52 EMULATION FLAG.
	JP	KERMIT
; THIS IS THE FILE-WARNING SET SUBCOMMAND
FILWAR	CALL	ONOFF
	LD	(FLWFLG),A	; SET THE FILE-WARNING FLAG.
	JP	KERMIT
;
SETCPM	LD	DE,TYPTAB
	CALL	ONOFFA
	LD	(CPMFLG),A	;SET THE CPM FLAG
	JP	KERMIT
;	Set Printer command
PRINTR	CALL	ONOFF
	LD	(PRTFLG),A
	JP	KERMIT
;SET DEBUG
SETBUG	CALL	ONOFF
	LD	(DBFLG),A
	JP	KERMIT
;
ONOFF	LD	DE,ONTAB
ONOFFA	LD	A,CMKEY
	CALL	COMND
	JP	ONOFF2
	LD	(TEMP1),A
	LD	A,CMCFM
	CALL	COMND
	JP	ONOFF3
	LD	A,(TEMP1)
	RET
ONOFF2	POP	AF
	JP	KERMT2
ONOFF3	POP	AF
	JP	KERMT3
; THIS IS THE SHOW COMMAND.
SHOW	LD	A,SHLEN	; GET THE OFFSET TO OVERWRITE WITH
	LD	(SETTAB),A	;FIX SET TABLE FOR SHOW
	LD	(SETTAB+1),A
	LD	A,'s'		;LAST CHARACTER IN ALL DESCRIPTION
	LD	(SETHLP),A	;FIX THIS TABLE TOO
	LD	A,CMKEY
	LD	DE,SHOTAB
	LD	HL,SHOHLP
	CALL	COMND
	JP	KERMT2
	CP	KYLEN		;IS THIS THE SHOW KEY COMMAND?
	JR	Z,NOCFM		;SKIP THE CONFIRM
	LD	(TEMP1),A	;SAVE THE JUMP OFFSET
	LD	A,CMCFM
	CALL	COMND		;GET A CONFIRM
	JP	KERMT3		;SAY NOT CONFIRMED ON AN ERROR
	LD	A,(TEMP1)
NOCFM	LD	HL,SHOJTB
	LD	C,A
	LD	B,0
	XOR	A		;DISABLE DIRECT CURSOR ADDRESSING 12 APR 86
	LD	(PRTSTR-2),A	;			12 APR 86 DAVORK
	ADD	HL,BC		;HL IS WHERE WE GO
	LD	BC,SHORET	;MAKE A RETURN ADDRESS
	PUSH	BC
	JP	(HL)		;GO DO THE ROUTINE
SHORET	LD	A,13		;ENABLE DIRECT CURSOR ADDRESSING 12 APR 86
	LD	(PRTSTR-2),A	;			12 APR 86 DAVORK
	CALL	NEWLIN		;PRINT A NEW LINE
	JP	KERMIT		;GO GET A NEW COMMAND
;	SHOW JUMP TABLE
SHOJTB	JP	ECSTAT		;SHOW ESCAPE
	JP	ESTAT		;SHOW LOCAL ECHO
	JP	FSTAT		;SHOW WARNING
	JP	CSTAT		;SHOW FILE-MODE
	JP	CKSTAT		;SHOW BLOCK-CHECK-TYPE
	JP	VSTAT		;SHOW VT-52
	JP	PSTAT		;SHOW PRINTER
	JP	GSTAT		;SHOW DEBUGGING
	JP	DSTAT		;SHOW DEFAULT DISK
	JP	BSTAT		;BELL STATUS
	JP	BASTAT		;SHOW BAUD
	JP	IBSTAT		;SHOW IBM
	JP	PASTAT		;SHOW PARITY
	JP	RSTAT		;SHOW RECEIVE
	JP	SSTAT		;SHOW SEND
	JP	BKSTAT		;SHOW BACKSPACE
KYLEN	EQU	$-SHOJTB	;THESE 2 LINES MUST REMAIN TOGETHER
	JP	KYSTAT		;SHOW A KEY TRANSLATION
	JP	FLSTAT		;SHOW FLOW CONTROL
	JP	SHOINP		;SHOW INPUT PARAMETERS
	JP	SHOOTP		;SHOW OUTPUT PARAMETERS
	JP	TKSTAT		;SHOW STATUS OF TAKE DISPLAY
	JP	EBSTAT		;SHOW STATUS OF STRIP-EIGHTH 31 MAR 86 DAVORK
	JP	WLSTAT		; SHOW WORD LENGTH
	JP	STSTAT		; SHOW STOP BITS
	JP	RTSTAT		; SHOW RTS
	JP	DTSTAT		; SHOW DTR
	JP	STAT01		; 'SHOW ALL'
;	Print ON or OFF based on the status of the Accumulator
COFFON	LD	DE,OFFSTR	;START WITH OFF AS DEFAULT
	OR	A		;SET THE FLAGS
	JP	Z,PRTSTR	;GO PRINT OFF IF A ZERO
	LD	DE,ONSTR	;ELSE PRINT ON
	JP	PRTSTR
;	THIS IS THE STATUS COMMAND.
STATUS	LD	A,CMCFM		;GET A CONFIRM
	CALL	COMND
	JP	KERMT3		;QUIT ON AN ERROR
	CALL	STAT01		;GO PRINT ALL THE VALUES
	JP	KERMIT
;	Print the status of all settable values
STAT01	LD	A,13		;ENABLE DIRECT CURSOR ADDRESSING 12 APR 86
	LD	(PRTSTR-2),A	; WHEN ALL PARAMETERS WANTED	12 APR 86
	XOR	A
	LD	(PRTSTR-1),A	;DISABLE CR's
	LD	DE,CLRTOP	;CLEAR THE SCREEN
	CALL	PRTSTR
	LD	DE,STHLP	;GET THE TOP OF SCREEN HEADER
	CALL	PRTSTR		;PRINT IT
	CALL	RSSTAT
	CALL	BSTAT
	CALL	ESTAT
	CALL	VSTAT
	CALL	CSTAT
	CALL	DSTAT
	CALL	FSTAT
	CALL	GSTAT
	CALL	PSTAT
	CALL	CKSTAT
	CALL	ECSTAT
	CALL	IBSTAT
	CALL	BKSTAT
	CALL	FLSTAT
	CALL	EBSTAT				; 31 MAR 86 DAVORK
	CALL	TKSTAT
	CALL	QUSTAT
	CALL	PRTST2
	DB	20,21,0,'$'
	LD	A,13
	LD	(PRTSTR-1),A
	RET ; NO NEWLINE NEEDED, SINCE FULL SCREEN IS USED
;	PRINT STATUS SUBROUTINES FOR EACH SETTABLE VALUE
EBSTAT	LD	DE,STRST			; 31 MAR 86 DAVORK
	CALL	PRTSTR				; 31 MAR 86 DAVORK
	LD	A,(STRFLG)			; 31 MAR 86 DAVORK
	CALL	COFFON				; 31 MAR 86 DAVORK
	RET					; 31 MAR 86 DAVORK
WLSTAT	LD	HL,WLS010			; 13 APR 86 DAVORK
	LD	DE,WLENST			; WLSTAT, STSTAT,
	JR	UARTCO				; UARTCO, RTSTAT, &
WLS010	LD	A,(IY+0)			; DTSTAT ADDED
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	AND	3
	ADD	A,'5'
	CP	'6'
	JR	NZ,WLS011
	LD	A,'7'
	JR	WLS015
WLS011	CP	'7'
	JR	NZ,WLS015
	LD	A,'6'
WLS015	LD	(WLS020+2),A
	CALL	PRTST2
WLS020	DB	' ',16,'8',17,'$'
	RET
STSTAT	LD	HL,STS010
	LD	DE,STOPST
	JR	UARTCO
STS010	LD	A,'1'
	BIT	4,(IY+0)
	JR	Z,WLS015
	INC	A
	JR	WLS015
UARTCO	LD	(UAR030+1),HL
	LD	(UAR020+1),DE
	CALL	PRTST2
	DB	CR,'RS232  :- $'
	LD	IY,(CLMOD)
UAR010	CALL	UAR020
	CALL	PRTST2
	DB	CR,'Kermit :- $'
	LD	IY,CLCOPY
UAR020	LD	DE,RTSST
	CALL	PRTSTR
UAR030	JP	RTS010
RTSTAT	LD	HL,RTS010
	LD	DE,RTSST
	JR	UARTCO
RTS010	XOR	A		; 0 TO PRINT 'NO'
	BIT	0,(IY+0)
RTS015	JR	NZ,RTS020
	INC	A		; 1 TO PRINT 'YES'
RTS020	CALL	COFFON
	RET
DTSTAT	LD	HL,DTS010
	LD	DE,DTRST
	JR	UARTCO
DTS010	XOR	A
	BIT	1,(IY+0)
	JR	RTS015
PASTAT	LD	HL,PAS000			; 03 APR 86 DAVORK
	LD	DE,PARST			; (UPDATED 13 APR)
	JR	UARTCO
PAS000	BIT	3,(IY+0)		;CHECK FOR PARITY ON/OFF
	JR	Z,PAS010;IT'S ON
	CALL	PRTST2
	DB	16,'disabled',17,'$'
	RET
PAS010	BIT	7,(IY+0)		;CHECK FOR PARITY
	JR	Z,PAS020
	CALL	PRTST2
	DB	16,'even',17,'$'
	RET
PAS020	CALL	PRTST2
	DB	16,'odd',17,'$'
	RET
BASTAT	LD	HL,BAS010		; 03 APR 86 DAVORK
	LD	DE,BAUDST		; (UPDATED 13 APR 86)
	JP	UARTCO
BAS010	LD	A,(IY+1)	;BAUD RATE
	PUSH	AF		;SAVE FOR LATER
	AND	0FH		;GET LOWER NIBBLE
	CALL	BAUDSR;CALL BAUD O/P SUBROUTINE
	CALL	PRTST2
	DB	17,' baud, Transmit is ',16,'$'
	POP	AF
	SRL	A		;GET HIGHER NIBBLE
	SRL	A
	SRL	A
	SRL	A
	CALL	BAUDSR
	CALL	PRTST2
	DB	17,' baud$'
	RET
BAUDSR	LD	B,A
	LD	DE,SPDTAB+3
	INC	B
	JR	BAU020		;GO TO END IN WEIRD CASE OF 50 BAUD
BAU010	LD	A,(DE)		;ADVANCE TO NEXT STRING
	INC	DE
	CP	'$'
	JR	NZ,BAU010
	INC	DE		;GET PAST 2ND DATA ELEMENT IN TABLE
	INC	DE		;GET PASSED LENGTH OF STRING
BAU020	DJNZ	BAU010		;LOOP 'TIL ONE FOUND
	CALL	PRTSTR		;FOUND ONE !
	RET
TKSTAT	LD	DE,TAKST
	CALL	PRTSTR
	LD	A,(TAKLOG)
	CALL	COFFON
	RET
SHOINP	CALL	NEWLIN		;GET A NEW LINE
	LD	DE,CSEST	;GET CASE IGNORE STRING
	CALL	PRTSTR
	LD	A,(CSEFLG)
	CALL	COFFON
	LD	DE,IDSPST
	CALL	PRTSTR
	LD	A,(INDSP)
	CALL	COFFON
	RET
SHOOTP	LD	DE,HSTEST	;GET HOST ECHO STRING
	CALL	NEWLIN		;PRINT A NEW LINE
	CALL	PRTSTR
	LD	A,(ECHFLG)
	CALL	COFFON
	LD	DE,ODSPST
	CALL	PRTSTR
	LD	A,(OTDSP)
	CALL	COFFON
	CALL	NEWLIN
	RET
FLSTAT	LD	DE,FLOWST
	CALL	PRTSTR
	LD	DE,XONSTR
	LD	A,(FLOFLG)
	OR	A
	JR	NZ,FLST10
	LD	DE,NONSTR
FLST10	JP	PRTSTR
BKSTAT	LD	DE,BACKST	;PRINT THE STRING
	CALL	PRTSTR
	LD	A,(BCKCHR)	;GET WHAT IT IS
	LD	DE,BCKSPC	;GET THE BACKSPACE STRING
	CP	32		;IS IT LESS THAN A SPACE
	JP	P,BAST01	;GO IF IT ISN'T
	JP	PRTSTR		;PRINT WHAT IT IS
BAST01	LD	DE,BCKDEL	;GE THE DELETE STRING
	JP	PRTSTR
RSSTAT	LD	DE,RSST				;12 APR 86 DAVORK
	CALL	PRTSTR				;To display UART params
	LD	IY,(CLMOD)
	LD	A,4
	LD	(RSR010+1),A
	CALL	RSS010
	LD	IY,CLCOPY
	LD	A,5
	LD	(RSR010+1),A
RSS010	LD	A,14
	CALL	RSROU
	LD	A,(IY+1)
	AND	0FH
	CALL	BAUDSR
	LD	A,22
	CALL	RSROU
	LD	A,(IY+1)
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	CALL	BAUDSR
	LD	A,33
	CALL	RSROU
	LD	A,(IY+0)
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	AND	3
	ADD	A,'5'		; tandy designed a funny UART !
	CP	'6'
	JR	NZ,RSS012
	LD	A,'7'
	JR	RSS014
RSS012	CP	'7'
	JR	NZ,RSS014
	LD	A,'6'
RSS014	LD	C,A
	LD	A,2;@DSP
	RST	28H
	LD	A,40
	CALL	RSROU
	BIT	3,(IY+0)
	JR	Z,RSS020
	CALL	PRTST2
	DB	'OFF$'
	JR	RSS040
RSS020	BIT	7,(IY+0)
	JR	Z,RSS030
	CALL	PRTST2
	DB	'EVEN$'
	JR	RSS040
RSS030	CALL	PRTST2
	DB	'ODD$'
RSS040	LD	A,50
	CALL	RSROU
	LD	A,'1'
	BIT	4,(IY+0)
	JR	Z,RSS050
	INC	A
RSS050	LD	C,A
	LD	A,2;@DSP
	RST	28H
	LD	A,56
	CALL	RSROU
	BIT	0,(IY+0)
	CALL	RSS060
	LD	A,60
	CALL	RSROU
	BIT	1,(IY+0)
RSS060	JR	Z,RSS070
	CALL	PRTST2
	DB	'OFF$'
	RET
RSS070	CALL	PRTST2
	DB	'ON$'
	RET
RSROU	LD	(RSR010+2),A
	CALL	PRTST2
RSR010	DB	20,4,14,'$'
	RET
IBSTAT	LD	DE,IBMST
	CALL	PRTSTR
	LD	A,(IBMFLG)
	CALL	COFFON
	RET
DISSND	LD	DE,SENDST
	JP	PRTSTR
DISREC	LD	DE,RECST
	JP	PRTSTR
;	SHOW STATUS OF ALL SEND & RECEIVE PARAMS ON FULL SCREEN DISPLAY
QUSTAT	LD	DE,QUST			; 13 APR 86 DAVORK
	CALL	PRTSTR
	LD	A,27
	LD	(QUR010+2),A
	LD	A,7
	LD	(QUR010+1),A
	CALL	QUROU
	LD	A,(REOL)
	CALL	ANOUT
	CALL	QUROU
	LD	A,(RPADCH)
	CALL	ANOUT
	CALL	QUROU
	LD	A,(RPAD)
	CALL	ANOUT
	CALL	QUROU
	LD	A,(RTIME)
	CALL	ANOUT
	CALL	QUROU
	LD	A,(RSOHCH)
	CALL	ANOUT
	CALL	QUROU
	LD	A,(RQUOTE)
	CALL	ESCPR1
	LD	A,7
	LD	(QUR010+1),A
	LD	A,35
	LD	(QUR010+2),A
	CALL	QUROU
	LD	A,(SEOL)
	CALL	ANOUT
	CALL	QUROU
	LD	A,(SPADCH)
	CALL	ANOUT
	CALL	QUROU
	LD	A,(SPAD)
	CALL	ANOUT
	CALL	QUROU
	LD	A,(STIME)
	CALL	ANOUT
	CALL	QUROU
	LD	A,(SSOHCH)
	CALL	ANOUT
	CALL	QUROU
	LD	A,(SQUOTE)
	CALL	ESCPR1
	RET
QUROU	LD	A,(QUR010+1)
	INC	A
	LD	(QUR010+1),A
	CALL PRTST2
QUR010	DB	20,8,27,'$'
	RET
;	SHOW STATUS OF ALL SEND PARAMETERS
SSTAT	LD	A,CMCFM
	CALL	COMND
	JP	KERMT3
	CALL	NEWLIN
	CALL	DISSND
	LD	DE,EOLST
	CALL	PRTSTR
	LD	A,(SEOL)
	CALL	ANOUT
	CALL	DISSND
	LD	DE,PCHST
	CALL	PRTSTR
	LD	A,(SPADCH)
	CALL	ANOUT
	CALL	DISSND
	LD	DE,PADST
	CALL	PRTSTR
	LD	A,(SPAD)
	CALL	ANOUT
	CALL	DISSND
	LD	DE,QTEST
	CALL	PRTSTR
	LD	A,(SQUOTE)
	CALL	ESCPR1
	CALL	DISSND
	LD	DE,TOST
	CALL	PRTSTR
	LD	A,(STIME)
	CALL	ANOUT
	CALL	DISSND
	LD	DE,SOPST
	CALL	PRTSTR
	LD	A,(SSOHCH)
	CALL	ANOUT
	RET
;	SHOW STATUS OF ALL RECEIVE PARAMETERS
RSTAT	LD	A,CMCFM
	CALL	COMND
	JP	KERMT3
	CALL	NEWLIN
	CALL	DISREC
	LD	DE,EOLST
	CALL	PRTSTR
	LD	A,(REOL)
	CALL	ANOUT
	CALL	DISREC
	LD	DE,PCHST
	CALL	PRTSTR
	LD	A,(RPADCH)
	CALL	ANOUT
	CALL	DISREC
	LD	DE,PADST
	CALL	PRTSTR
	LD	A,(RPAD)
	CALL	ANOUT
	CALL	DISREC
	LD	DE,QTEST
	CALL	PRTSTR
	LD	A,(RQUOTE)
	CALL	ESCPR1
	CALL	DISREC
	LD	DE,TOST
	CALL	PRTSTR
	LD	A,(RTIME)
	CALL	ANOUT
	CALL	DISREC
	LD	DE,SOPST
	CALL	PRTSTR
	LD	A,(RSOHCH)
	CALL	ANOUT
	RET
BSTAT	LD	DE,BELSTR
	CALL	PRTSTR
	LD	A,(BELFLG)	;GET THE FLAG
	JP	COFFON		;PRINT THE STATUS
ESTAT	LD	DE,LOCST	;GET THE HEADER TO PRINT
	CALL	PRTSTR		;PRINT IT
	LD	A,(ECOFLG)	; GET THE LOCAL ECHO FLAG.
	JP	COFFON
VSTAT	LD	DE,VTEMST	; GET THE VT52 EMULATION STRING.
	CALL	PRTSTR
	LD	A,(VTFLG)
	JP	COFFON
CSTAT	LD	DE,CPMST	; GET THE MESSAGE
	CALL	PRTSTR
	LD	DE,DEFSTR	;GET THE DEFAULT MESSAGE
	LD	A,(CPMFLG)	;CHECK THE STATUS
	OR	A		; IS IT ON?
	JR	Z,STAT21	; IF NOT SAY SO.
	CP	1		; ASCII?
	LD	DE,ASCSTR
	JR	Z,STAT21	; SAY ASCII
	LD	DE,BINSTR	; SAY BINARY
STAT21	JP	PRTSTR		; PRINT WHAT IS IN DE
DSTAT	LD	DE,DSKDEF	;GET THE MESSAGE
	CALL	PRTSTR		;PRINT IT
	CALL	STDOUT		;REVERSE VIDEO ON
	LD	A,(DEFDSK)	;GET THE CHARACTER 0-9
	CALL	CONOUT
	JP	STDEND		;REVERSE VIDEO OFF
FSTAT	LD	DE,FILST	; FILE WARNING STRING.
	CALL	PRTSTR
	LD	A,(FLWFLG)	;GET THE STATUS
	JP	COFFON		;GO PRINT THE STATUS
GSTAT	LD	DE,BUGST	;debug string
	CALL	PRTSTR
	LD	A,(DBFLG)	;GET THE STATUS
	JP	COFFON		;PRINT THE STATUS
PSTAT	LD	DE,PNTSTR	;printer string
	CALL	PRTSTR
	LD	A,(PRTFLG)	;get printer flag
	JP	COFFON		;GO PRINT IT
CKSTAT	LD	DE,BCKST	; GET THE STRING
	CALL	PRTSTR		; PRINT "BLOCK CHECK TYPE "
	CALL	STDOUT		;REVERSE VIDEO ON
	LD	A,(CHKTYP)	; GET THE TYPE (CHARACTER 1, 2, OR 3)
	CALL	CONOUT
	CALL	STDEND		;REVERSE VIDEO OFF
	LD	DE,BCKST1	; GET REST OF TEXT ("-CHARACTER")
	JP	PRTSTR		;  .  .  .
ECSTAT	LD	DE,ESCST	; ESCAPE STRING.
	CALL	PRTSTR
	CALL	STDOUT		;REVERSE VIDEO ON
	CALL	ESCPR		; PRINT THE ESCAPE CHAR.
	JP	STDEND		;REVERSE VIDEO OFF
LOGONE	PUSH	AF
	PUSH	DE
	LD	E,A
	LD	A,(LOGFLG)
	OR	A
	LD	A,E
	CALL	NZ,LOGIT
	POP	DE
	POP	AF
	RET
